unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, DXSounds;

type
  TMainForm = class(TForm)
    DXSound: TDXSound;
    Xosc: TTrackBar;
    MainMenu1: TMainMenu;
    FileMenu: TMenuItem;
    FileEnd: TMenuItem;
    VolumeTrackBar: TTrackBar;
    PanLabel: TLabel;
    VolumeLabel: TLabel;
    Bevel1: TBevel;
    O1: TMenuItem;
    GlobalFocusItem: TMenuItem;
    Timer1: TTimer;
    trigger: TCheckBox;
    TRadioCanale: TRadioGroup;
    low1: TTrackBar;
    lowtp: TLabel;
    ontop: TCheckBox;
    Interrupt: TTrackBar;
    procedure FormShow(Sender: TObject);
    procedure XoscChange(Sender: TObject);
    procedure VolumeTrackBarChange(Sender: TObject);
    procedure FileEndClick(Sender: TObject);
    procedure GlobalFocusItemClick(Sender: TObject);
    procedure DXSoundFinalize(Sender: TObject);
    procedure DXSoundInitialize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure UpdateView;
    procedure low1Change(Sender: TObject);

    procedure trigger2  ;
    procedure minionda  ;
    procedure ontopClick(Sender: TObject);

  private
    FUpdating: Boolean;
   
  public

    Audio: TAudioStream;
    Capture: TSoundCaptureStream;
 //   procedure UpdateView;
  end;

var
  MainForm: TMainForm;
  modo2:integer=-8000;      //ltp
  modo:integer=8000;       // utp
  xpunti:integer=650;
  bc,pc:integer;
  vedi:array [0..33] of integer;
  buffer:array [0..1600] of integer;
 // function trigger(aa,bb:integer):integer ;

 //    function trigger2(aa,bb:integer):integer ;

implementation
 

{$R *.DFM}

// function TMainForm.trigger2(aa,bb:integer):integer  ;
procedure TMainForm.trigger2  ;

var
 d,i2,j2,dis  :                      integer;
 condizione, siutp, siltp:         boolean ;

begin
condizione:=not trigger.Checked;
if condizione=false then
begin

   j2:=0;
   siutp:=false;
   siltp:=false;

  repeat
              inc (j2);
         repeat //supera l' utp
            inc(j2);
            if j2>1000 then siutp:=true;
            if j2>1000 then condizione:=true;
            Audio.WaveStream.ReadBuffer(d,4);
            d:=d div 65536;  if d>32768 then d:=d-65536;
            if d>modo then siutp:=true;
         until siutp;
         repeat //supera in negativo l' ltp
            inc(j2);
            if j2>1000 then condizione:=true;
            if j2>1000 then siltp:=true;
            Audio.WaveStream.ReadBuffer(d,4);
            d:=d div 65536;  if d>32768 then d:=d-65536;
            if d<modo2 then siltp:=true;
         until siltp;
            siutp:=false;
         repeat //supera l' utp
            inc(j2);
            if j2>1000 then condizione:=true;
            if j2>1000 then siutp:=true;
            Audio.WaveStream.ReadBuffer(d,4);
            d:=d div 65536;  if d>32768 then d:=d-65536;
            if d>modo then condizione:=true;
            if d>modo then siutp:=true;
         until siutp;


   until condizione=true ;
end;

end;

procedure TMainForm.DXSoundInitialize(Sender: TObject);
begin
    bc:=canvas.brush.color ;
    pc:=canvas.pen.color  ;
    canvas.brush.color:= clbtnface ;
    canvas.pen.color:= clbtnface   ;
    canvas.rectangle(0,100,1024+31,768);
    canvas.brush.color:= bc ;
    canvas.pen.color:= pc   ;

  Capture := TSoundCaptureStream.Create(nil);

  Capture.CaptureFormat := Capture.SupportedFormats.Count-1;
  Capture.Start;

  Audio := TAudioStream.Create(DXSound.DSound);
  Audio.WaveStream := Capture;
  Audio.BufferLength := 3000;
  //Audio.AutoUpdate:=true ;

  Audio.Volume:=-10000;
  Audio.wavestream.SetPCMFormat(44100,16, 1) ;

  Audio.Play;
  UpdateView;


  Xosc.Enabled := True;
  VolumeTrackBar.Enabled := True;
  
 
  
  try

    //PanTrackBar.Position := Audio.Pan;
    //VolumeTrackBar.Position := Audio.Volume;
  finally
    FUpdating := False;
  end;
end;

procedure TMainForm.DXSoundFinalize(Sender: TObject);
begin
  Audio.Free; Audio := nil;
  Capture.Free; Capture := nil;
end;



procedure TMainForm.FormShow(Sender: TObject);
begin

    UpdateView;
end;

procedure TMainForm.XoscChange(Sender: TObject);  //n. di punti
begin
  if not FUpdating then
  begin
    xpunti:= xosc.Position;
   if xpunti>680 then
   begin
    MainForm.Width:=xosc.Position+32;
    UpdateView;
    canvas.brush.color:= clbtnface ;
    canvas.pen.color:= clbtnface   ;
   //  canvas.rectangle(0,100,1024+31,768);
    canvas.rectangle(0,100,xosc.Position+32,768);
    canvas.brush.color:= bc ;
    canvas.pen.color:= pc   ;
    end
    else
    begin
    MainForm.Width:=680+32;
    UpdateView;
    canvas.brush.color:= clbtnface ;
    canvas.pen.color:= clbtnface   ;
    canvas.rectangle(0,100,680+32,768);
    canvas.brush.color:= bc ;
    canvas.pen.color:= pc   ;
    end;
  end;
end;

procedure TMainForm.VolumeTrackBarChange(Sender: TObject);
begin
  if not FUpdating then
  begin
   modo:= VolumeTrackBar.Position;
    UpdateView;
  end;
end;




procedure TMainForm.low1Change(Sender: TObject);
begin
   modo2:= low1.Position;
   UpdateView;
end;
procedure TMainForm.UpdateView;
 var i:integer;
  begin

  //if Audio<>nil then
 // begin
    PanLabel.Caption := Format('punti:  %d', [xpunti ]);
    VolumeLabel.Caption := Format('u.t.p. : %d', [modo]);
    lowtp.Caption := Format('l.t.p. : %d', [modo2]);


end;

procedure TMainForm.FileEndClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.GlobalFocusItemClick(Sender: TObject);
begin

  GlobalFocusItem.Checked := not GlobalFocusItem.Checked;

  if GlobalFocusItem.Checked then
    DXSound.Options := DXSound.Options + [soGlobalFocus]
  else
    DXSound.Options := DXSound.Options - [soGlobalFocus];

  if Audio<>nil then
  begin
    {  Buffer re-making  }
    Audio.RecreateBuf;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var i:integer;
begin

   {  Because I want to display the exception,  AutoInitialize professional patty is not used.  }
  try

    DXSound.Initialize;

  except
    on E: Exception do
    begin
      Application.ShowMainForm := False;
      Application.HandleException(E);
      Application.Terminate;
    end;
  end;
end;



procedure TMainForm.Timer1Timer(Sender: TObject);
var dd,d,x,i,i2,j,j2,precedente,dis,nero,rosso,primo  : integer;
    condizione, siutp,siltp:                         boolean  ;
    xnero,ynero,xrosso,yrosso:           integer;//  word;

begin
 
 { canvas.brush.color:= bc ;
  canvas.pen.color:= pc   ;
  i:=(25*modo) div 32768;
  canvas.MoveTo(280,-i+75);
  canvas.lineTo(305,-i+75);
  i:=(25*modo2) div 32768;
  canvas.MoveTo(300,-i+75);
  canvas.lineTo(340,-i+75);
    //canvas.polyline([point(300,75),point(310,50),point(330,99),point(340,75)]);
 }
if TRadioCanale.ItemIndex=0 then
begin
 canvas.pen.color:= pc;
 x:=-1    ;
 dis:=30 ;

 canvas.pen.color:= clbtnface   ;
 canvas.MoveTo(0,100);
 canvas.lineto(0,768);
// canvas.pen.color:= pc   ;
 canvas.MoveTo(-40,300);
 trigger2;

  canvas.pen.color:= 1000;

  for i:=0 to xpunti do
    begin
    Audio.WaveStream.ReadBuffer(d,4);
     buffer[i]:=d  ;
     d:=d div 65536;  if d>32768 then d:=d-65536;

     d:=d div 200;
     x:=x+1;
     canvas.lineto(x,300-d);
     //x:=i div 4;
     if x>xpunti then x:=-1;
     inc (dis);
    if dis=31  then
     begin
     canvas.brush.color:= clbtnface ;
     canvas.pen.color:= clbtnface   ;
     canvas.rectangle(x+1,100,x+32,768);
     canvas.brush.color:= bc ;
     canvas.pen.color:= 1000  ;
     canvas.moveto(x,300-d);
     dis:=0;
     end  ;
     end;
     minionda;
 end;//semode=0


if TRadioCanale.ItemIndex=1 then  //canalesinistro
begin
 canvas.pen.color:= pc   ;

 x:=-1    ;
 dis:=30 ;

    canvas.pen.color:= clbtnface   ;
    canvas.MoveTo(0,100);
    canvas.lineto(0,768);
    canvas.pen.color:= 1000;
    canvas.MoveTo(-40,300);
    trigger2;



 for i:=0 to xpunti do
    begin
    Audio.WaveStream.ReadBuffer(d,4);
     buffer[i]:=d  ;
     d:=d shl 16; d:=d div 65536; if d>32768 then d:=d-65536;

     d:=d div 200 ;
     x:=x+1;
     canvas.lineto(x,300-d);
     //x:=i div 4;
     if x>xpunti then x:=-1;
     inc (dis);
    if dis=31  then
     begin
     canvas.brush.color:= clbtnface ;
     canvas.pen.color:= clbtnface   ;
     canvas.rectangle(x+1,100,x+32,768);
     canvas.brush.color:= bc ;
     canvas.pen.color:= pc   ;
     canvas.moveto(x,300-d);
     dis:=0;
     end  ;
     end;
     minionda;
 end;//semode=1


  if TRadioCanale.ItemIndex=2 then // stereo
begin
 x:=-1    ;
 dis:=30 ;

    canvas.pen.color:= clbtnface   ;
    canvas.MoveTo(0,100);
    canvas.lineto(0,768);
    canvas.pen.color:= pc;
    canvas.MoveTo(-40,300);
    nero:=300;
    rosso:=300;

    trigger2;



 for i:=0 to xpunti do
    begin
    Audio.WaveStream.ReadBuffer(d,4);
     buffer[i]:=d  ;
     dd:=d  ;
     d:=d shl 16; d:=d div 65536; if d>32768 then d:=d-65536;

     d:=d div 200 ;
     x:=x+1;
    // canvas.pen.color:= pc  ;
     canvas.moveto(x-1,nero);
     nero:=300-d  ;
     canvas.lineto(x,nero);

    d:=dd;
    d:=d div 65536;   if d>32768 then d:=d-65536;
    d:=d div 200;
   // canvas.pen.color:= 1000;
    canvas.moveto(x-1,rosso);
    rosso:=300-d  ;
    canvas.lineto(x,rosso);



     if x>xpunti then x:=-1;
     inc (dis);
     if dis=31  then
     begin
     canvas.brush.color:= clbtnface ;
     canvas.pen.color:= clbtnface   ;
     canvas.rectangle(x+1,100,x+32,768);
     canvas.brush.color:= bc ;
     canvas.pen.color:= pc   ;
     canvas.moveto(x,300-d);
     dis:=0;
     end  ;
      
     end;
    minionda;
 end;//semode=2


  if TRadioCanale.ItemIndex=3 then // stereo
begin
    primo:=0;
    x:=-1    ;
    canvas.pen.color:= clbtnface   ;
    canvas.MoveTo(0,100);
    canvas.lineto(0,768);
    canvas.pen.color:= pc;
    canvas.MoveTo(-40,300);
    yrosso:=300;
    xrosso:=-1;
         for x:=1 to 10000000   //evita sfarfallamento;
          do
          begin

          end;
       trigger2;
       x:=-1 ;
     canvas.brush.color:= clbtnface ;
     canvas.pen.color:= clbtnface   ;
     canvas.rectangle(x+1,100,x+32,768);
     canvas.brush.color:= bc ;
     canvas.pen.color:= pc  ;


     x:=-1    ;
     dis:=30  ;
     i2:=0     ;
 for i:=0 to xpunti do
    begin
    Audio.WaveStream.ReadBuffer(d,4);
     buffer[i]:=d  ;
     vedi[i2]:=d  ;
     inc(i2);
     d:=d shl 16; d:=d div 65536; if d>32768 then d:=d-65536;

     d:=d div 200 ;
     x:=x+1;

     canvas.lineto(x,300-d);


      if i2=30 then     //scrive rosso
      begin
      xnero:=x;
      ynero:=300-d;
      x:=x-30;
      i2:=i2-30;
      canvas.pen.color:= 1000;
        canvas.moveto(xrosso,yrosso);
        for j:=1 to 30 do
        begin
         d:=vedi[i2];
         d:=d div 65536;   if d>32768 then d:=d-65536;
         d:=d div 200;
         canvas.lineto(x+1,300-d);
         inc(i2);
         inc(x);
        end;
        xrosso:=x;
        yrosso:=300-d;
        i2:=0;


       canvas.brush.color:= clbtnface ;
       canvas.pen.color:= clbtnface   ;
       canvas.rectangle(x+1,100,x+32,768);
       canvas.brush.color:= bc ;
       canvas.pen.color:= pc   ;
       canvas.moveto(xnero,ynero);

      end; //if i2=30

        end; //ciclo for  principale

         //ultimo tratto rosso
         d:=buffer[xpunti-32];
         d:=d div 65536;   if d>32768 then d:=d-65536;
         d:=d div 200;
         canvas.moveto(xpunti-32,300-d);
         canvas.pen.color:= 1000;
        for i:=xpunti-31 to xpunti do

        begin
         d:=buffer[i];
         d:=d div 65536;   if d>32768 then d:=d-65536;
         d:=d div 200;
         canvas.lineto(i,300-d);
        end;

        minionda;


 end;//semode=3

 end;//della procedura



 procedure TMainForm.minionda  ;

var
 i,d :          integer;
 condizione :              boolean;
 begin

 condizione:=not trigger.Checked;
 canvas.brush.color:= clbtnface ;
 canvas.pen.color:= clbtnface   ;
 canvas.rectangle(280,50,341,100);
  if condizione=false then
  begin
       
       canvas.brush.color:= bc ;
       canvas.pen.color:= pc   ;
       i:=(25*modo) div 32768;
       canvas.MoveTo(280,-i+75);
       canvas.lineTo(305,-i+75);
       i:=(25*modo2) div 32768;
       canvas.MoveTo(300,-i+75);
       canvas.lineTo(340,-i+75);
       d:=buffer[0];
       d:=d div 65536;   if d>32768 then d:=d-65536;
       d:=d div 1300;
       canvas.moveto(300,75-d);
    for i:=0 to 40 do
      begin
         d:=buffer[i*8];
         d:=d div 65536;   if d>32768 then d:=d-65536;
         d:=d div 1310;
         canvas.lineto(300+i,75-d);
      end;
      end; //condizione
  end;  //fine procedura minionda






procedure TMainForm.ontopClick(Sender: TObject);
begin

if ontop.Checked=true then
  begin
    MainForm.formStyle:=fsStayOnTop
  end 
  else
  begin
    MainForm.formStyle:=fsnormal ;
  end
end;

end. //fine programma
